SystemOrganization addCategory: #'btb-presentation'!

Model subclass: #BankDomainObject
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

BankDomainObject class
	instanceVariableNames: 'Cache'!

BankDomainObject subclass: #BankAccount
	instanceVariableNames: 'type recentTransactions balance user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!BankAccount methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 20:38'!
setSavings

	self type: #Savings! !

!BankAccount class methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 00:08'!
blaineSavings1

	^BankAccount new
		id: 'Fun';
		setSavings;
		balance: (BankAmount on: 5945);
		addTransactions: (BankTransaction randomTransactions: 10 using: self defaultPlaces)! !

!BankAccount class methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 00:08'!
aliceChecking2

	^BankAccount new
		id: 'Frye';
		setChecking;
		balance: (BankAmount on: 507583);
		addTransactions: (BankTransaction randomTransactions: 10 using: self defaultPlaces)! !

!BankAccount methodsFor: 'accessing' stamp: 'btb 4/25/2004 20:30'!
user: anObject
	"Set the value of user"

	user _ anObject! !

!BankAccount methodsFor: 'accessing' stamp: 'btb 4/25/2004 20:30'!
type: anObject
	"Set the value of type"

	type _ anObject! !

!BankAccount methodsFor: 'accessing' stamp: 'btb 4/26/2004 00:02'!
addTransaction: aTransaction

	^self recentTransactions add: aTransaction! !

!BankAccount methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 00:10'!
recentTransactionTotal

	^self recentTransactions inject: (BankAmount on: 0) into: [:sum :each | sum + each amount]! !

!BankAccount methodsFor: 'accessing' stamp: 'btb 4/25/2004 20:30'!
recentTransactions: anObject
	"Set the value of recentTransactions"

	recentTransactions _ anObject! !

!BankAccount class methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 00:03'!
aliceChecking1

	^BankAccount new
		id: 'Gail';
		setChecking;
		balance: (BankAmount on: -898);
		addTransactions: (BankTransaction randomTransactions: 10 using: self defaultPlaces)! !

!BankAccount methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 22:55'!
canTransfer: anAmount to: anotherAccount

	^self balance > anAmount! !

!BankAccount class methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 00:08'!
blaineChecking

	^BankAccount new
		id: 'My Checking';
		setChecking;
		balance: (BankAmount on: 100567);
		addTransactions: (BankTransaction randomTransactions: 10 using: self defaultPlaces)! !

!BankAccount methodsFor: 'accessing' stamp: 'btb 4/25/2004 20:30'!
user
	"Answer the value of user"

	^ user! !

!BankAccount methodsFor: 'accessing' stamp: 'btb 4/25/2004 20:30'!
balance
	"Answer the value of balance"

	^ balance! !

!BankAccount methodsFor: 'accessing' stamp: 'btb 4/25/2004 20:30'!
type
	"Answer the value of type"

	^ type! !

!BankAccount methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 20:38'!
setChecking

	self type: #Checking! !

!BankAccount methodsFor: 'accessing' stamp: 'btb 4/25/2004 20:30'!
balance: anObject
	"Set the value of balance"

	balance _ anObject! !

!BankAccount methodsFor: 'accessing' stamp: 'btb 4/25/2004 20:30'!
recentTransactions
	"Answer the value of recentTransactions"

	^ recentTransactions! !

!BankAccount methodsFor: 'accessing' stamp: 'btb 4/26/2004 00:02'!
addTransactions: aCollection

	self recentTransactions addAll: aCollection! !

!BankAccount methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 20:34'!
<= anotherBankAccount

	^self type <= anotherBankAccount type! !

!BankAccount methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 21:16'!
initialize

	super initialize.
	self recentTransactions: OrderedCollection new! !

!BankAccount methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 22:31'!
subtract: anAmount

	self balance - anAmount! !

!BankAccount methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 22:11'!
printOn: aStream

	aStream nextPutAll: self id! !

!BankAccount class methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 00:08'!
blaineSavings2

	^BankAccount new
		id: 'Retirement';
		setSavings;
		balance: (BankAmount on: 45626439);
		addTransactions: (BankTransaction randomTransactions: 10 using: self defaultPlaces)! !

!BankAccount methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 00:11'!
beforeBalance

	^self balance deepCopy - self recentTransactionTotal.! !

!BankAccount class methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 00:07'!
defaultPlaces

	^#('Killer Records' 
		'School''s Out Ice Cream' 
		'Billion Dollar Management' 
		'Hey Stoopid Golf' 
		'Raise Your Fist Consulting'
		'Constrictor Wholesale'
		'Last Temptation Church'
		'Nightmare Music'
		'Flush The Fashion Mailorder'
		'Dada Painting')! !

!BankAccount class methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 00:08'!
aliceSavings

	^BankAccount new
		id: 'Rosetta';
		setSavings;
		balance: (BankAmount on: 1077746);
		addTransactions: (BankTransaction randomTransactions: 10 using: self defaultPlaces)! !

!BankAccount methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 22:30'!
add: anAmount

	self balance + anAmount! !

!BankAccount methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 00:36'!
transfer: anAmount to: anotherAccount

	self subtract: anAmount.
	anotherAccount add: anAmount.
	self recentTransactions 
		add: (BankTransaction new 
				amount: (anAmount deepCopy asNegative);
				title: ('Transfer To ', anotherAccount printString);
				date: Date today).
	anotherAccount recentTransactions
		add: (BankTransaction new 
				amount: anAmount;
				title: ('Transfer From ', self printString);
				date: Date today).! !

BankDomainObject subclass: #BankTransaction
	instanceVariableNames: 'type amount title date'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!BankTransaction methodsFor: 'accessing' stamp: 'btb 4/26/2004 00:00'!
date: anObject
	"Set the value of date"

	date _ anObject! !

!BankTransaction methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 00:01'!
<= anotherTransaction

	^self date <= anotherTransaction date! !

!BankTransaction methodsFor: 'accessing' stamp: 'btb 4/25/2004 20:35'!
amount: anObject
	"Set the value of amount"

	amount _ anObject! !

!BankTransaction class methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 00:01'!
randomTransactions: size using: titleCollection

	| result date |
	result := OrderedCollection new: size.
	date := Date today subtractDays: 7.
	size timesRepeat:
		[| instance |
		 instance := BankTransaction new.
		 result add: instance.
		 instance date: (date copy addDays: (1 to: 7) atRandom).
		 instance amount: (BankAmount on: (-10000 to: 10000) atRandom).
		 instance title: (titleCollection at: (1 to: titleCollection size) atRandom)].
	^result asSortedCollection asOrderedCollection! !

!BankTransaction methodsFor: 'accessing' stamp: 'btb 4/25/2004 20:36'!
title
	"Answer the value of title"

	^ title! !

!BankTransaction methodsFor: 'accessing' stamp: 'btb 4/25/2004 20:35'!
amount
	"Answer the value of amount"

	^ amount! !

!BankTransaction methodsFor: 'accessing' stamp: 'btb 4/26/2004 00:00'!
date
	"Answer the value of date"

	^ date! !

!BankTransaction methodsFor: 'accessing' stamp: 'btb 4/25/2004 20:36'!
title: anObject
	"Set the value of title"

	title _ anObject! !

!BankTransaction methodsFor: 'accessing' stamp: 'btb 4/26/2004 00:00'!
type
	"Answer the value of type"

	^ type! !

!BankTransaction methodsFor: 'accessing' stamp: 'btb 4/26/2004 00:00'!
type: anObject
	"Set the value of type"

	type _ anObject! !

!BankDomainObject methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 17:39'!
hash

	^self id hash! !

!BankDomainObject methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 17:39'!
= anotherUser

	^[self id = anotherUser id] on: MessageNotUnderstood do: [:ex | false]! !

!BankDomainObject class methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 17:47'!
cache

	^Cache ifNil: 
		[self initializeCache. 
		 Cache]! !

!BankDomainObject class methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 17:42'!
new

	^self basicNew initialize! !

!BankDomainObject class methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 17:49'!
loadCache

	! !

BankDomainObject subclass: #BankUser
	instanceVariableNames: 'displayName password accounts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!BankUser methodsFor: 'accessing' stamp: 'btb 4/25/2004 17:31'!
accounts
	"Answer the value of accounts"

	^ accounts! !

!BankUser methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 20:07'!
initialize

	super initialize.
	self accounts: OrderedCollection new.! !

!BankUser methodsFor: 'accessing' stamp: 'btb 4/25/2004 17:32'!
displayName
	"Answer the value of displayName"

	^ displayName! !

!BankUser methodsFor: 'accessing' stamp: 'btb 4/25/2004 21:30'!
accountsDo: aBlock

	self accounts asSortedCollection do: aBlock! !

!BankUser class methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 17:50'!
loadCache

	self addToCache: self aliceCooper.
	self addToCache: self blaineBuxton.! !

!BankUser methodsFor: 'accessing' stamp: 'btb 4/25/2004 17:31'!
password: anObject
	"Set the value of password"

	password _ anObject! !

!BankUser class methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 23:03'!
blaineBuxton

	^self new
		id: 'btbuxton';
		displayName: 'Blaine Buxton';
		password: 'metal';
		addAccount: BankAccount blaineSavings1;
		addAccount: BankAccount blaineSavings2;
		addAccount: BankAccount blaineChecking! !

!BankUser class methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 19:22'!
allUsers

	^self cache values! !

!BankUser methodsFor: 'accessing' stamp: 'btb 4/25/2004 20:33'!
addAccount: anAccount

	self accounts add: anAccount.
	anAccount user: self.! !

!BankUser methodsFor: 'accessing' stamp: 'btb 4/25/2004 17:31'!
accounts: anObject
	"Set the value of accounts"

	accounts _ anObject! !

!BankUser methodsFor: 'accessing' stamp: 'btb 4/25/2004 17:31'!
password
	"Answer the value of password"

	^ password! !

!BankUser class methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 22:59'!
aliceCooper

	^self new
		id: 'alice';
		displayName: 'Alice Cooper';
		password: 'coop';
		addAccount: BankAccount aliceSavings;
		addAccount: BankAccount aliceChecking1;
		addAccount: BankAccount aliceChecking2! !

!BankUser methodsFor: 'accessing' stamp: 'btb 4/25/2004 17:32'!
displayName: anObject
	"Set the value of displayName"

	displayName _ anObject! !

!BankDomainObject class methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 17:44'!
forId: anId

	^self cache at: anId ifAbsent: [self error: 'Not Found']! !

!BankDomainObject class methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 18:26'!
resetCache

	Cache := nil! !

!BankDomainObject methodsFor: 'accessing' stamp: 'btb 4/25/2004 17:39'!
id: anObject
	"Set the value of id"

	id _ anObject! !

!BankDomainObject methodsFor: 'accessing' stamp: 'btb 4/25/2004 17:39'!
id
	"Answer the value of id"

	^ id! !

!BankDomainObject methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 17:41'!
initialize! !

!BankDomainObject class methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 17:48'!
addToCache: aBankDomainObject

	self cache at: aBankDomainObject id put: aBankDomainObject! !

!BankDomainObject class methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 18:26'!
resetAll

	self allSubclassesDo: [:each |
		each resetCache]! !

!BankDomainObject class methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 17:49'!
initializeCache

	Cache:=Dictionary new.
	self loadCache.! !

WAComponent subclass: #PresentationPage
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

PresentationPage subclass: #BrowserPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!BrowserPage methodsFor: 'rendering' stamp: 'btb 4/24/2004 21:02'!
renderContentOn: html

	html unorderedList:
		[html listItem: 'Development tools built in browser'.
		 html divClass: 'subtext' with:
			[html text: 'This reduced switching back and forth'].
		 html listItem: 'Morphic-like halos around components'.
		 html divClass: 'subtext' with:
			[html text: 'Allows you to browse HTML source'; break.
			 html text: 'Inspect page code and instances'].
		 html listItem: 'Memory monitor'.
		 html listItem: 'Profiler'.
		 html listItem: 'Configure via the browser']! !

!BrowserPage methodsFor: 'names' stamp: 'btb 4/24/2004 14:14'!
subtitle

	^'Morphic-like Browser Integration' ! !

PresentationPage subclass: #ConclusionPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!ConclusionPage methodsFor: 'names' stamp: 'btb 4/24/2004 14:14'!
subtitle

	^'Conclusion'! !

!ConclusionPage methodsFor: 'rendering' stamp: 'btb 4/26/2004 00:58'!
renderContentOn: html

	html unorderedList:
		[html listItem: 
				[html text: 'Seaside is more than '.
				 html attributes style: 'font-style: italic'.
				 html spanClass: 'jawm' with: 'Just Another Web Framework'.
				 html attributes style: 'font-size:50%'.
				 html spanClass: 'tm' with: 'tm'].
		 html listItem: 'Seaside brings fun into web development'.
		 html listItem: 
			[html text: 'Visit '.
			 html anchorWithUrl: 'http://www.beta4.com/seaside2' do: 'http://www.beta4.com/seaside2'.
			 html text: ' for more info'].
		 html listItem: 'Download Seaside from Squeak via SqueakMap'.
		 html divClass: 'subtext' with: 
			[html text: 'Download Squeak from '.
			 html anchorWithUrl: 'http://www.squeak.org' do: 'http://www.squeak.org']]! !

!PresentationPage methodsFor: 'accessing' stamp: 'btb 4/24/2004 18:48'!
next: anObject
	"Set the value of next"

	next _ anObject! !

!PresentationPage methodsFor: 'initialization' stamp: 'btb 4/25/2004 11:15'!
initialize

	super initialize.
	self addDecoration: PresentationPageDecoration new.! !

!PresentationPage methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 19:52'!
inform: aString

	self call: (WAFormDialog new addMessage: aString; addDecoration: (PresentationPageDecoration new subtitle: self subtitle))! !

PresentationPage subclass: #SeasideVsStrutsPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!SeasideVsStrutsPage methodsFor: 'as yet unclassified' stamp: 'btb 4/27/2004 22:17'!
renderContentOn: html 
	html text: 'Wafer Weblog Comparison (Taken From Mailing List)'.
	html attributes style: 'font-size:48%;'.
	html
		divClass: 'quoted-short'
		with: [html
				blockquote: [html text: 'First the total size of what one downloads for each version. Yes the  
Java Struts download is ~160 times larger.'.
					html break.
					html
						bold: [html text: 'Size (uncompressed)';
								 break.
							html text: 'Java Struts Version 4.1MB (yes MB)';
								 break.
							html text: 'Seaside version 26,759 B (yes bytes)';
								 break.
							html break.
							html text: '# of Files';
								 break.
							html text: 'Java Struts Version 155';
								 break.
							html text: 'Seaside version 1';
								 break].
					html break.
					html text: 'Here is the total size  
of the source files. The java struts version is 8.9 times larger.'.
					html break.
					html
						bold: [html text: 'Source Size';
								 break.
							html text: 'Java Struts Version 239,330 B';
								 break.
							html text: 'Seaside version 26,759 B';
								 break].
					html break.
					html text: 'Most of the Java struct version files contain a copyright notice. When  
I remove the copyright we get that the Java struts version is 5.9 times  
larger.'.
					html break.
					html
						bold: [html text: 'Source w/o copyright notice';
								 break.
							html text: 'Java Struts Version 159,554 B';
								 break.
							html text: 'Seaside version 26,759 B';
								 break].
					html break.
					html text: 'Finally there is the number of classes.'.
					html break.
					html
						bold: [html text: 'Classes';
								 break.
							html text: 'Java Struts Version  36';
								 break.
							html text: 'Seaside version 12';
								 break].
					html break.
					html text: 'URLs for downloading the code are below.';
						 break.
					html break.
					html text: 'Blanchard''s Seaside implementation '.
					html text: '(http://lists.squeakfoundation.org/pipermail/seaside/attachments/ 
20030808/c411a24b/Wafer.obj)';
						 break.
					html break.
					html text: 'Java Struct version  '.
					html text: '(http://www.waferproject.org/weblog-prototype/index.jsp)';
						 break.
					html break.
					html text: 'Roger Whitney              Department of Computer Science';
						 break.
					html text: 'whitney at cs.sdsu.edu        San Diego State University';
						 break]].
	html break; break.
	self renderFullContentOn: html! !

!SeasideVsStrutsPage methodsFor: 'as yet unclassified' stamp: 'btb 4/27/2004 21:48'!
subtitle

	^'Seaside vs. Struts'! !

!SeasideVsStrutsPage methodsFor: 'as yet unclassified' stamp: 'btb 4/27/2004 22:07'!
renderFullContentOn: html 
	html text: 'Full Text:'.
	html attributes style: 'font-size:30%;font-style:italic'.
	html
		divClass: 'quoted-full'
		with: [html
				blockquote: [html text: 'Last month Todd Blanchard posted his Seaside implementation of the  
Wafer weblog. The Wafer weblog spec was created to compare different  
Java frameworks for Web applications. The idea is to implement the  
Wafer weblog using the different frameworks and compare the results. I  
downloaded Blanchard''s Seaside implementation and the Java Struct  
version. I have no idea how the Java Struts version compares to the  
other Java versions. It could be I picked a really bad Java example to  
look at. Here are some simple comparisons.'.
					html break; break.
					html text: 'First the total size of what one downloads for each version. Yes the  
Java Struts download is ~160 times larger.'.
					html break.
					html
						bold: [html text: 'Size (uncompressed)';
								 break.
							html text: 'Java Struts Version 4.1MB (yes MB)';
								 break.
							html text: 'Seaside version 26,759 B (yes bytes)';
								 break.
							html break.
							html text: '# of Files';
								 break.
							html text: 'Java Struts Version 155';
								 break.
							html text: 'Seaside version 1';
								 break].
					html break.
					html text: 'The struts version had a number of jar files that were needed to run  
the example. The jar files are rather large, and most were not actual  
created for the project. They were results of other projects.  It also  
had a number of XML files used to compile the example and configure  
struts. So I looked at the source files in each version for an idea of  
how much code one needed to implement each project. In the Java Struts  
version there were Java classes and jsp files. Here is the total size  
of the source files. The java struts version is 8.9 times larger.'.
					html break; break.
					html
						bold: [html text: 'Source Size';
								 break.
							html text: 'Java Struts Version 239,330 B';
								 break.
							html text: 'Seaside version 26,759 B';
								 break].
					html break.
					html text: 'Most of the Java struct version files contain a copyright notice. When  
I remove the copyright we get that the Java struts version is 5.9 times  
larger.'.
					html break.
					html
						bold: [html text: 'Source w/o copyright notice';
								 break.
							html text: 'Java Struts Version 159,554 B';
								 break.
							html text: 'Seaside version 26,759 B';
								 break].
					html break.
					html text: 'Finally there is the number of classes.'.
					html break.
					html
						bold: [html text: 'Classes';
								 break.
							html text: 'Java Struts Version  36';
								 break.
							html text: 'Seaside version 12';
								 break].
					html break.
					html text: 'I have no idea how hard it would be to actually run the Java Struct  
version. I would have to at least download and install Java Struts and  
what ever it needs to run. I did not try to look at the Java code to  
understand it. Nor do I have any idea what Struts are, but have run  
across a number of references to them.';
						 break.
					html break.
					html text: 'Todd has a smaller version, which could change the comparison a bit.';
						 break.
					html break.
					html text: 'URLs for downloading the code are below.';
						 break.
					html break.
					html text: 'Blanchard''s Seaside implementation '.
					html text: '(http://lists.squeakfoundation.org/pipermail/seaside/attachments/ 
20030808/c411a24b/Wafer.obj)';
						 break.
					html break.
					html text: 'Java Struct version  '.
					html text: '(http://www.waferproject.org/weblog-prototype/index.jsp)';
						 break.
					html text: '----';
						 break.
					html text: 'Roger Whitney              Department of Computer Science';
						 break.
					html text: 'whitney at cs.sdsu.edu        San Diego State University';
						 break.
					html text: 'http://www.eli.sdsu.edu/   San Diego, CA 92182-7720';
						 break.
					html text: '(619) 583-1978';
						 break.
					html text: '(619) 594-3535 (office)';
						 break.
					html text: '(619) 594-6746 (fax)']]! !

PresentationPage subclass: #ExtraWowPage
	instanceVariableNames: 'uploadedFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!ExtraWowPage methodsFor: 'as yet unclassified' stamp: 'btb 4/28/2004 18:50'!
downloadFileContents

	^'"title1","title2"', Character cr asString, '"34.00","45.00"'! !

!ExtraWowPage methodsFor: 'as yet unclassified' stamp: 'btb 4/28/2004 19:13'!
renderUploadFileOn: html

	html break; break.
	html text: 'Upload File Example'.
	html attributeAt: 'enctype' put: 'multipart/form-data'.
	html form: [
		html fileUploadWithCallback: [:f | uploadedFile := f].
		html submitButtonWithText: 'Upload'.
	].
	uploadedFile ifNotNil: [
		html text: uploadedFile fileName.
		html attributes style: 'font-size:25%'.
		html preformatted: uploadedFile contents contents].! !

!ExtraWowPage methodsFor: 'as yet unclassified' stamp: 'btb 4/28/2004 19:08'!
renderContentOn: html

	html text: 'Multiple Windows'; break.
	self renderMultipleWindowExampleOn: html.
	self renderDownloadFileOn: html.
	self renderUploadFileOn: html.! !

!ExtraWowPage methodsFor: 'as yet unclassified' stamp: 'btb 4/27/2004 20:42'!
renderMultipleWindowExampleOn: html

	| url1 url2 url3 url4 |
	url1 := html urlForAction: [self call: WACounter new].
	url2 := html urlForAction: [self call: WACounter new].
	url3 := html urlForAction: [self call: WACounter new].
	url4 := html urlForAction: [self call: WACounter new].
	
	html attributes onSubmit: 'JavaScript:openWindows(''', url1, ''',''',url2,''',''',url3,''',''',url4,''');'.
	html form: [html submitButtonWithText: 'Open Them All'].
	
	html attributes onSubmit: 'JavaScript:closeAll();'.
	html form: [html submitButtonWithText: 'Close Them All'].
	! !

!ExtraWowPage methodsFor: 'as yet unclassified' stamp: 'btb 4/27/2004 19:21'!
subtitle

	^'Extra Cool Stuff'! !

!ExtraWowPage methodsFor: 'as yet unclassified' stamp: 'btb 4/27/2004 20:41'!
script

	^'
	var window1, window2, window3, window4;
function openWindows(url, url2, url3, url4) {
	closeAll();
	window1=window.open(url, "counter1", "width=200,height=200,scrollbars=yes,menubar=yes, top=50, left=50");
	window2=window.open(url2, "counter2", "width=200,height=200,scrollbars=yes,menubar=yes, top=300, left=50");
	window3=window.open(url3, "counter3", "width=200,height=200,scrollbars=yes,menubar=yes, top=300, left=300");
	window4=window.open(url4, "counter4", "width=200,height=200,scrollbars=yes,menubar=yes, top=50, left=300");
}
function closeAll() {
	if (window1 !!= null) window1.close();
	if (window2 !!= null) window2.close();
	if (window3 !!= null) window3.close();
	if (window4 !!= null) window4.close();
	window1 = null;
	window2 = null;
	window3 = null;
	window4 = null;
}
'! !

!ExtraWowPage methodsFor: 'as yet unclassified' stamp: 'btb 4/28/2004 19:05'!
renderDownloadFileOn: html 
	html break.
	html anchorWithDocument: [self downloadFileContents] mimeType: 'application/octet-stream' fileName: 'download.csv' text: 'Download File Example'.! !

PresentationPage subclass: #BankExamplePage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!BankExamplePage methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 20:14'!
style

	^'
	.account {color:#000000;font-size:50%;}
	.account-summary {color:#000000;font-size:50%;}
	.negative {color:#ff0000;}
	.postive {color:#000000;}
	table.bank-spreadsheet th {
		background:#800000;
    		font-weight:bold;
		border-color: f6f6f6;
    		color:#F5DEB3;
	}
	table.bank-spreadsheet td {
		background:#FFDEC0;
		border-color: f6f6f6;
	}
	table.bank-spreadsheet td.total {
		background:#800000;
    		font-weight:bold;
		border-color: f6f6f6;
    		color:#F5DEB3;
	}
'! !

!BankExamplePage methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 19:53'!
call: aComponent

	| answer |
	answer := super call: aComponent.
	^answer == #logout
		ifTrue: [self isLogonPage ifFalse: [self answer: #logout]]
		ifFalse: [answer]! !

BankExamplePage subclass: #BankAccountPage
	instanceVariableNames: 'account'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!BankAccountPage methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 20:31'!
renderBalanceTableOn: html

	html cssClass: 'bank-spreadsheet'.
	html attributes
		border: 0;
		cellpadding: 4;
		cellspacing: 4.
	html table:
		[html tableRow: 
			[html attributes width: '100px'.
			html tableData: [html render: self account beforeBalance].
			html attributes width: '710px'.
			html tableData: 'Starting Balance'].
		html tableRow: 
			[html tableData: [html render: self account balance].
			html tableData: 'Ending Balance']].
	html break.! !

!BankAccountPage methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 20:33'!
renderAccountTableOn: html

	html attributes
		border: 0;
		cellpadding: 4;
		cellspacing: 4.
	html cssClass: 'bank-spreadsheet'.
	html table:
		[html attributes width: '100px'.
		html tableHeading: 'Amount'.
		html attributes width: '100px'.
		html tableHeading: 'Date'.
		html attributes width: '600px'.
		html tableHeading: 'Place'.
			 
		self account recentTransactions do: 
			[:eachTransaction | self renderTransactionRow: eachTransaction on: html].
		html tableRow: 
			[html cssClass: 'total'.
			html attributes style: 'text-align:right;'.
			html tableData: self account recentTransactionTotal.
			html cssClass: 'total'.
			html attributes colspan: 2.
			html tableData: 'Total']]! !

!BankAccountPage methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 17:06'!
renderTransactionRow: aTransaction on: html

	html tableRow: 
		[html attributes style: 'text-align:right;'.
		 html tableData: [html render: aTransaction amount].
		 html tableData: aTransaction date mmddyyyy.
		 html tableData: aTransaction title]! !

!BankAccountPage methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 20:31'!
renderContentOn: html
	html divClass: 'account' with:
		[self renderHeaderOn: html.
		 self renderBalanceTableOn: html.
		 self renderAccountTableOn: html]! !

!BankAccountPage methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 20:29'!
renderHeaderOn: html

	html form: 
		[html text: self account printString.
		 html text: ' '.
		 html text: self account type.
	  	 html text: ' Account Detail For '.
		 html text: self user displayName. 
		 html break.
		 html submitButtonWithAction: [self answer] text: 'Back To Summary'.
		 html submitButtonWithAction: [self answer: #logout] text: 'Log Out'].! !

!BankAccountPage methodsFor: 'accessing' stamp: 'btb 4/25/2004 23:22'!
account: anObject
	"Set the value of account"

	account _ anObject! !

!BankAccountPage methodsFor: 'accessing' stamp: 'btb 4/25/2004 23:22'!
account
	"Answer the value of account"

	^ account! !

!BankAccountPage methodsFor: 'accessing' stamp: 'btb 4/25/2004 23:22'!
user

	^self account user! !

!BankExamplePage methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 19:53'!
isLogonPage

	^false! !

BankExamplePage subclass: #BankAccountSummaryPage
	instanceVariableNames: 'user transferComponents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!BankAccountSummaryPage methodsFor: 'accessing' stamp: 'btb 4/25/2004 22:40'!
user: anObject
	"Set the value of user"

	user _ anObject.
	user ifNotNil: [user accountsDo: [:each | self addTransferComponent: (BankTransferComponent new fromAccount: each) for: each]].! !

!BankAccountSummaryPage methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 20:34'!
renderContentOn: html
	html divClass: 'account-summary' with:
		[self renderHeaderOn: html.
		 self renderSummaryTableOn: html].
		 ! !

!BankAccountSummaryPage methodsFor: 'accessing' stamp: 'btb 4/25/2004 22:41'!
transferComponents

	^transferComponents ifNil: [transferComponents := Dictionary new]! !

!BankAccountSummaryPage methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 20:28'!
renderHeaderOn: html

	html form: 
		[html text: ('Account Summary For ', self user displayName); break.
		 html submitButtonWithAction: [self answer] text: 'Log Out']! !

!BankAccountSummaryPage methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 00:17'!
renderAccountRow: anAccount on: html 
	html tableRow: 
		[html tableData: 
			[html anchorWithAction: [self gotoAccount: anAccount] fixTemps text: anAccount id].
			 html tableData: anAccount type.
			 html attributes style: 'text-align:right;'.
			 html tableData: [html render: anAccount balance].
			 html tableData: [html render: (self transferComponentFor: anAccount)]]! !

!BankAccountSummaryPage methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 20:34'!
renderSummaryTableOn: html

	html cssClass: 'bank-spreadsheet'.
	html attributes
		border: 0;
		cellpadding: 4;
		cellspacing: 4.
	 html table:
		[html attributes width: '150px'.
		html tableHeading: 'Id'.
		html attributes width: '100px'.
		html tableHeading: 'Type'.
		html attributes width: '100px'.
		html tableHeading: 'Balance'.
		html attributes width: '400px'.
		html tableHeading: 'Transfer'.
		self user accountsDo: 
			[:eachAccount | self renderAccountRow: eachAccount on: html]]
		 ! !

!BankAccountSummaryPage methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 22:41'!
transferComponentFor: anAccount

	^self transferComponents at: anAccount id! !

!BankAccountSummaryPage methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 23:23'!
gotoAccount: anAccount

	self call: (BankAccountPage new account: anAccount)! !

!BankAccountSummaryPage methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 22:40'!
addTransferComponent: aComponent for: anAccount

	self transferComponents at: anAccount id put: aComponent! !

!BankAccountSummaryPage methodsFor: 'accessing' stamp: 'btb 4/25/2004 17:17'!
user
	"Answer the value of user"

	^ user! !

!BankAccountSummaryPage methodsFor: 'accessing' stamp: 'btb 4/25/2004 22:38'!
children

	^self transferComponents values! !

BankExamplePage subclass: #BankLoginPage
	instanceVariableNames: 'userId password message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!BankLoginPage methodsFor: 'accessing' stamp: 'btb 4/25/2004 17:58'!
password
	"Answer the value of password"

	^ password! !

!BankLoginPage methodsFor: 'accessing' stamp: 'btb 4/25/2004 18:08'!
message
	"Answer the value of message"

	^ message ifNil: ['']! !

!BankLoginPage methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 20:00'!
renderContentOn: html

	html text: self message.
	self message: ''.
	html form:
		[html layoutTable:
			[html
				tableRowWithLabel: 'Username'
				column: [html textInputWithValue: (self userId ifNil: ['']) callback: [:value | self userId: value]].
			html
				tableRowWithLabel: 'Password'
				column: [html passwordInputWithCallback: [:value | self password: value]]].
			 html 
				submitButtonWithAction: 
					[self login]
				text: 'Login'].
	! !

!BankLoginPage methodsFor: 'accessing' stamp: 'btb 4/25/2004 18:06'!
message: anObject
	"Set the value of message"

	message _ anObject! !

!BankLoginPage methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 19:17'!
login

	| user |
	user := self obtainUser.
	user isNil
		ifTrue: [self message: 'Invalid Login. Please Try Again.']
		ifFalse: [self answer: user]! !

!BankLoginPage methodsFor: 'accessing' stamp: 'btb 4/25/2004 17:58'!
userId: anObject
	"Set the value of userId"

	userId _ anObject! !

!BankLoginPage methodsFor: 'accessing' stamp: 'btb 4/25/2004 17:58'!
userId
	"Answer the value of userId"

	^ userId! !

!BankLoginPage methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 19:14'!
obtainUser

	| login |
	^[login := BankUser forId: self userId.
	 (login password = self password) 
		ifTrue: [login]
		ifFalse: [self error: 'Invalid password']] on: Error do: [:ex | nil]
	! !

!BankLoginPage methodsFor: 'accessing' stamp: 'btb 4/25/2004 17:58'!
password: anObject
	"Set the value of password"

	password _ anObject! !

!BankLoginPage methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 19:53'!
isLogonPage

	^true! !

!BankExamplePage methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 17:59'!
subtitle

	^'Bank Example'! !

PresentationPage subclass: #PresentationIntroPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!PresentationIntroPage methodsFor: 'rendering' stamp: 'btb 4/24/2004 16:10'!
renderContentOn: html
	html unorderedList:
		[
			html listItem: 'A framework for developing sophisticated web applications in Smalltalk'.
			html listItem: 'Models an entire user session as a continuous piece of code'.
			html divClass: 'subtext' with: 
				[html text: 'Pages can call and return to each other like subroutines'; break.
				 html text: 'Complex sequences of forms can be managed from a single method'; break.
				 html text: 'Objects are passed by reference rather than marshalled into URLs or hidden fields'; break.
				 html text: 'Fully supports the backtracking and parallelism inherent to the web browser'].
			html listItem: 'Plus A Lot More'.
			html divClass: 'subtext' with:
				[html text: ' Callback-based event model'; break.
				 html text: 'A "transaction" system for auto-expiring pages'; break.
				 html text: 'Programmer-friendly HTML generation and designer-friendly templates'; break.
				 html text: 'A system of reusable and embeddable UI components'; break.
				 html text: 'Super cool and handy web-based development tools']].! !

!PresentationIntroPage methodsFor: 'names' stamp: 'btb 4/24/2004 14:06'!
subtitle

	^'Introduction'! !

PresentationPage subclass: #PresentationTitlePage
	instanceVariableNames: 'previousCache pageCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!PresentationTitlePage commentStamp: 'btb 4/24/2004 14:53' prior: 0!
PresentationTitlePage initialize

WAKom startOn: 9090.
WAKom stop.

WADispatcher default entryPoints removeKey: 'presentation'


http://localhost:9090/seaside/presentation!

!PresentationTitlePage methodsFor: 'rendering' stamp: 'btb 4/27/2004 21:48'!
renderContentOn: html

	html divClass: 'toc' with: 
		[html tag: #ol do: 
			[html divClass: 'items' with: 
				[self renderTOCItemForPage: PresentationIntroPage on: html.
			 	 self renderTOCItemForPage: ContinuationsPage on: html.
			 	 self renderTOCItemForPage: LameGuessingGame on: html.
			 	 self renderTOCItemForPage: BrowserPage on: html.
				 self renderTOCItemForPage: ComplicatedExampleStartPage on: html.
				 self renderTOCItemForPage: SeasideVsStrutsPage on: html.
				 self renderTOCItemForPage: ExtraWowPage on: html.
			 	 self renderTOCItemForPage: ConclusionPage on: html]]].
	self previousCache: nil.! !

!PresentationTitlePage class methodsFor: 'as yet unclassified' stamp: 'btb 4/24/2004 14:41'!
initialize

		self registerAsApplication: 'presentation'! !

!PresentationTitlePage methodsFor: 'accessing' stamp: 'btb 4/24/2004 18:50'!
previousCache: anObject
	"Set the value of previousCache"

	previousCache _ anObject! !

!PresentationTitlePage methodsFor: 'rendering' stamp: 'btb 4/24/2004 14:06'!
subtitle

	^'Agenda'! !

!PresentationTitlePage methodsFor: 'accessing' stamp: 'btb 4/24/2004 21:05'!
pageCache
	"Answer the value of pageCache"

	^ pageCache ifNil: [pageCache := Dictionary new]! !

!PresentationTitlePage methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 11:25'!
goHome

	^self! !

!PresentationTitlePage class methodsFor: 'as yet unclassified' stamp: 'btb 4/24/2004 15:10'!
canBeRoot

	^true! !

!PresentationTitlePage methodsFor: 'rendering' stamp: 'btb 4/25/2004 11:19'!
renderTOCItemForPage: aPresentationPageClass on: html
		| page |
		page := self pageCache at: aPresentationPageClass ifAbsentPut: [aPresentationPageClass new].
		self previousCache 
			ifNil: [self next: page] 
			ifNotNil: [self previousCache next: page].
		self previousCache: page.
		html listItem: [html anchorWithAction: [self call: page] text: page subtitle]! !

!PresentationTitlePage methodsFor: 'accessing' stamp: 'btb 4/24/2004 18:50'!
previousCache
	"Answer the value of previousCache"

	^ previousCache! !

!PresentationPage methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 19:10'!
call: aComponent

	| answer |
	answer := super call: aComponent.
	^answer == #home
		ifTrue: [self goHome]
		ifFalse: [answer]! !

!PresentationPage methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 11:24'!
goHome

	^self answer: #home! !

!PresentationPage methodsFor: 'names' stamp: 'btb 4/24/2004 14:02'!
subtitle

	^'Default'! !

PresentationPage subclass: #LameGuessingGame
	instanceVariableNames: 'state range guessingMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!LameGuessingGame methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 08:40'!
radioButtonsRenderGuessingOn: html using: newNumber
	| group |
	group := html radioGroup.
	html
		form: [html
				radioButtonInGroup: group
				selected: false
				callback: [self state: #Win];
				 text: 'YES!!';
				 break.
			html
				radioButtonInGroup: group
				selected: false
				callback: [self
						range: (self range first to: newNumber - 1)];
				 text: 'No It''s Less';
				 break.
			html
				radioButtonInGroup: group
				selected: false
				callback: [self
						range: (newNumber + 1 to: self range last)];
				 text: 'No It''s More';
				 break.
			html
				radioButtonInGroup: group
				selected: true
				callback: [self answer];
				 text: 'This is LAME';
				 break.
			html submitButtonWithText: 'DO IT!!']! !

!LameGuessingGame methodsFor: 'accessing' stamp: 'btb 4/25/2004 08:36'!
guessingMode

	^guessingMode! !

!LameGuessingGame methodsFor: 'as yet unclassified' stamp: 'btb 4/24/2004 21:47'!
renderWinOn: html

	html text: 'I WON!!'.
	html form:
		[html submitButtonWithAction: 
			[self state: #Initial] text: 'Play Again. This is fun!!'.
		 html submitButtonWithAction:
			[self answer] text: 'You Nuts? This is LAME!!']
	! !

!LameGuessingGame methodsFor: 'accessing' stamp: 'btb 4/24/2004 21:20'!
state: anObject
	"Set the value of state"

	state contents: anObject! !

!LameGuessingGame methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 10:35'!
renderGuessingOn: html 
	| newNumber |
	newNumber := self range atRandom.
	html text: 'Is Your number: '.
	html text: newNumber printString.
	html text: '?'.
	
	self perform: (self guessingMode, 'RenderGuessingOn:using:') asSymbol with: html with: newNumber.
	
	html break.
	
	html attributeAt: 'name' put: 'guessingMode'.
	html form: 
		[html attributeAt: 'onchange' put: 'JavaScript: document.guessingMode.submit();'.
		 html selectFromList: #(buttons links radioButtons) selected: self guessingMode callback: [:each | self guessingMode: each]].
	! !

!LameGuessingGame methodsFor: 'accessing' stamp: 'btb 4/24/2004 21:20'!
state
	"Answer the value of state"

	^ state contents! !

!LameGuessingGame methodsFor: 'accessing' stamp: 'btb 4/25/2004 08:36'!
guessingMode: anObject

	guessingMode := anObject! !

!LameGuessingGame methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 08:38'!
linksRenderGuessingOn: html using: newNumber

	html break.
	html anchorWithAction: 
		[self state: #Win] text: 'YES!!'; break.
	html anchorWithAction:
		[self range: (self range first to: (newNumber - 1))] text: 'No It''s Less'; break.
	html anchorWithAction:
		[self range: ((newNumber + 1) to: self range last)] text: 'No It''s More'; break.
	html anchorWithAction:
		[self answer] text: 'This is LAME'! !

!LameGuessingGame methodsFor: 'as yet unclassified' stamp: 'btb 4/24/2004 21:36'!
renderInitialOn: html

	html text: 'Pick a Number between 1 and 100'.
	html form: 
		[html submitButtonWithAction: 
			[self state: #Guessing. 
			 self range: (1 to: 100)] text: 'Go!!'].
	! !

!LameGuessingGame methodsFor: 'accessing' stamp: 'btb 4/24/2004 21:37'!
range
	"Answer the value of range"

	^ range contents! !

!LameGuessingGame methodsFor: 'rendering' stamp: 'btb 4/25/2004 15:20'!
renderContentOn: html

	html break.
	html attributeAt: 'style' put: 'text-align:center;'.
	html divNamed: 'simple-contents' with: 
		[html text: 'The Lame Guessing Game'; break.
		 self perform: ('render', self state, 'On:') asSymbol with: html]! !

!LameGuessingGame methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 08:37'!
buttonsRenderGuessingOn: html using: newNumber

	html form: 
		[html submitButtonWithAction: 
			[self state: #Win] text: 'YES!!'.
		 html submitButtonWithAction:
			[self range: (self range first to: (newNumber - 1))] text: 'No It''s Less'.
		 html submitButtonWithAction:
			[self range: ((newNumber + 1) to: self range last)] text: 'No It''s More'.
		 html submitButtonWithAction:
			[self answer] text: 'This is LAME'
	]
	! !

!LameGuessingGame methodsFor: 'initialization' stamp: 'btb 4/25/2004 15:15'!
initialize

	super initialize.
	state:=WAStateHolder new contents: #Initial.
	range:=WAStateHolder new.
	guessingMode := #buttons.! !

!LameGuessingGame methodsFor: 'accessing' stamp: 'btb 4/24/2004 21:37'!
range: anObject
	"Set the value of range"

	range contents: anObject! !

!LameGuessingGame methodsFor: 'names' stamp: 'btb 4/25/2004 15:18'!
subtitle

	^'A Simple Example'! !

!PresentationPage methodsFor: 'accessing' stamp: 'btb 4/24/2004 18:48'!
next
	"Answer the value of next"

	^ next! !

PresentationPage subclass: #ComplicatedExampleStartPage
	instanceVariableNames: 'showHelp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!ComplicatedExampleStartPage methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 19:59'!
initialize

	super initialize.
	self showHelp: false.! !

!ComplicatedExampleStartPage methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 15:25'!
subtitle

	^'A More Complicated Example'! !

!ComplicatedExampleStartPage methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 20:03'!
renderContentOn: html

	html text: 'This example shows off more of Seaside''s features'; break; break.
	html form: 
		[html submitButtonWithAction: [self go] text: 'Let''s Do This'.
		html break; break.
		html submitButtonWithAction: [BankDomainObject resetAll] text: 'Reset Domain'.
		html submitButtonWithAction: [self showHelp: self showHelp not] text: 'Login Help'].
	self showHelp ifTrue: [self renderHelpOn: html].
	! !

!ComplicatedExampleStartPage methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 20:04'!
renderHelpOn: html

	html break.
	html attributes style: 'font-size: 50%'.
	
	html divClass: 'help' with:
		[html bold: 'User Ids To Login With'; break.
			BankUser allUsers do: [:eachUser |
				html bold: [html text: eachUser displayName].
				html break.
				html text: 'Username: ', eachUser id.
				html break.
				html text: 'Password: ', eachUser password.
				html break]]! !

!ComplicatedExampleStartPage methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 20:05'!
go

	| bankUser accountPage |
	bankUser := self call: BankLoginPage new.
	accountPage := BankAccountSummaryPage new user: bankUser.
	self isolate: [self call: accountPage]! !

!ComplicatedExampleStartPage methodsFor: 'accessing' stamp: 'btb 4/26/2004 19:59'!
showHelp: anObject
	"Set the value of showHelp"

	showHelp _ anObject! !

!ComplicatedExampleStartPage methodsFor: 'accessing' stamp: 'btb 4/26/2004 19:59'!
showHelp
	"Answer the value of showHelp"

	^ showHelp! !

PresentationPage subclass: #ContinuationsPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!ContinuationsPage methodsFor: 'rendering' stamp: 'btb 4/24/2004 17:38'!
renderContentOn: html

	html unorderedList:
		[
			html listItem: 'History Of Continuations In The Web'.
			html divClass: 'subtext' with: 
				[html text: 'Introduced in Scheme (Considered an academic exercise)'; break.
				 html text: 'Paul Graham created first continuation-based framework in Lisp'; break.
				 html text: 'Avi Bryant refined the idea'].
			html listItem: 'Why Continuations Are Great'.
			html divClass: 'subtext' with: 
				[html text: 'Simplifies calls to external systems without request/response baggage'; break.
				 html text: 'Calls look like regular procedure calls'; break.
				 html text: 'Handles the back button problem by "walking back up the stack"'].
			html listItem: 'Continuations Are The Not Only Part Of Seaside'.
			html divClass: 'subtext' with: 
				[html text: 'Makes caching state is easy which can be problematic in any server'; break.
				 html text: 'View pieces of page as components'; break.
				 html text: 'Reduces amount of code needed for web applications'; break.
				 html text: 'Several pre-built components'; break.
				 html text: 'Makes dealing with html a breeze'].
			].! !

!ContinuationsPage methodsFor: 'names' stamp: 'btb 4/24/2004 17:38'!
subtitle

	^'Continuations And Beyond'! !

WAComponent subclass: #BankTransferComponent
	instanceVariableNames: 'amount toAccount fromAccount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!BankTransferComponent methodsFor: 'accessing' stamp: 'btb 4/25/2004 22:16'!
amount: anObject
	"Set the value of amount"

	amount _ anObject! !

!BankTransferComponent methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 17:02'!
go

	| realAmount |
	realAmount := [BankAmount on: (self amount asNumber * 100) asInteger] on: Error do: [:ex | self inform: 'Bad Amount. Try Again'. ^self].
	self toAccount ifNil: [self inform: 'Bad Account. Try Again'. ^self].
	(self fromAccount canTransfer: realAmount to: self toAccount)
		ifFalse: [self inform: 'Insufficient Funds. Try Again'. ^self].
	(self confirm: 'Transfer ', realAmount printString, ' to: ', self toAccount printString, '?')
		ifTrue: 
			[self fromAccount transfer: realAmount to: self toAccount].
	self toAccount: nil.
	self amount: nil! !

!BankTransferComponent methodsFor: 'accessing' stamp: 'btb 4/25/2004 22:16'!
toAccount
	"Answer the value of toAccount"

	^ toAccount! !

!BankTransferComponent methodsFor: 'accessing' stamp: 'btb 4/25/2004 22:16'!
amount
	"Answer the value of amount"

	^ amount! !

!BankTransferComponent methodsFor: 'accessing' stamp: 'btb 4/25/2004 22:16'!
fromAccount: anObject
	"Set the value of fromAccount"

	fromAccount _ anObject! !

!BankTransferComponent methodsFor: 'accessing' stamp: 'btb 4/25/2004 22:16'!
toAccount: anObject
	"Set the value of toAccount"

	toAccount _ anObject! !

!BankTransferComponent methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 17:01'!
renderContentOn: html

	html form: 
		[html textInputWithCallback: [:value | self amount: value].
		 html text: ' To: '.
		 html selectFromList: (self accountsFor: self fromAccount user minus: self fromAccount) selected: nil callback: [:value | self toAccount: value].
		 html submitButtonWithAction: [self isolate: [self go]] text: 'Transfer']! !

!BankTransferComponent methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 22:22'!
accountsFor: aUser minus: anAccount

	| result |
	result := OrderedCollection new.
	aUser accountsDo: [:each | each = anAccount ifFalse: [result add: each]].
	^result! !

!BankTransferComponent methodsFor: 'accessing' stamp: 'btb 4/25/2004 22:16'!
fromAccount
	"Answer the value of fromAccount"

	^ fromAccount! !

!BlockContext methodsFor: '*btb-presentation' stamp: 'btb 4/28/2004 19:03'!
asMIMEDocument

	^self value asMIMEDocument! !

Object subclass: #BankAmount
	instanceVariableNames: 'cents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!BankAmount methodsFor: 'accessing' stamp: 'btb 4/25/2004 20:40'!
cents
	"Answer the value of cents"

	^ cents! !

!BankAmount methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 20:45'!
onlyCents

	^self cents abs \\ 100! !

!BankAmount methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 22:30'!
+ anotherAmount

	^self cents: (self cents + anotherAmount cents)! !

!BankAmount methodsFor: 'accessing' stamp: 'btb 4/25/2004 20:40'!
cents: anObject
	"Set the value of cents"

	cents _ anObject! !

!BankAmount methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 16:53'!
renderOn: html
	| className |
	className := self isNegative 
		ifTrue: ['negative']
		ifFalse: ['positive'].
	html spanClass: className with: [html spanClass: 'balance' with: self printString].
	
	! !

!BankAmount methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 20:45'!
dollars

	^self cents abs // 100! !

!BankAmount methodsFor: 'as yet unclassified' stamp: 'btb 4/26/2004 00:33'!
asNegative

	self cents: self cents negated! !

!BankAmount methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 22:30'!
- anotherAmount

	^self cents: (self cents - anotherAmount cents)! !

!BankAmount methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 22:56'!
> anotherAmount

	^self cents > anotherAmount cents! !

!BankAmount methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 21:06'!
formatDollars

	^self dollars printString! !

!BankAmount class methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 21:05'!
on: cents

	^self new
		cents: cents! !

!BankAmount methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 21:11'!
printOn: aStream
	| isNegative |
	isNegative := self cents negative.
	isNegative ifTrue: [aStream nextPut: $(].
	aStream 
		nextPutAll: self formatDollars;
		nextPut: $.;
		nextPutAll: (self padWithZeros: self onlyCents printString size: 2).
	isNegative ifTrue: [aStream nextPut: $)].! !

!BankAmount methodsFor: 'accessing' stamp: 'btb 4/25/2004 21:45'!
isNegative

	^self cents negative! !

!BankAmount methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 21:12'!
padWithZeros: aString size: aSize

	| size difference result |
	size := aString size.
	(size >= aSize) ifTrue: [^aString].
	difference := aSize - size.
	result := aString.
	difference timesRepeat: [result := '0', result].
	^result! !

WADecoration subclass: #PresentationPageDecoration
	instanceVariableNames: 'subtitle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-presentation'!

!PresentationPageDecoration methodsFor: 'rendering' stamp: 'btb 8/18/2004 19:48'!
renderContentOn: html

	html divClass: 'title' with: 
		[html attributes id: 'heading'.
		 html divClass: 'heading' with: 'Seaside'.
		 html script: 'changeHeadingColor();'.
		 html spanClass: 'description' with: 'We Got The Power'.
		 html spanClass: 'utility' with: 
			[html anchorWithAction: [self component answer] do: '<<'.
			 html anchorWithAction: [self callHomePage] do: 'H'.
			self hasNextPage ifTrue: 
				[html anchorWithAction: [self callNextPage] do: '>>']]].
	html divClass: 'subtitle' with: self subtitle.
	html divClass: 'content' with: [self renderOwnerOn: html].
	! !

!PresentationPageDecoration methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 16:29'!
obtainSubtitle

	^[self component subtitle] on: MessageNotUnderstood do: [:ex | '']! !

!PresentationPageDecoration methodsFor: 'as yet unclassified' stamp: 'btb 4/24/2004 19:06'!
callNextPage

	| nextPage |
	nextPage := self component next.
	nextPage ifNotNil: [self component call: nextPage]! !

!PresentationPageDecoration methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 11:25'!
callHomePage

	self component answer: #home! !

!PresentationPageDecoration methodsFor: 'rendering' stamp: 'btb 4/28/2004 19:53'!
script

	^'
function changeHeadingColor() {
	document.all.heading.style.color="#800000";
	setTimeout("document.all.heading.style.color=\"#f51010\"", 50);
	setTimeout("document.all.heading.style.color=\"#f52020\"", 100);
	setTimeout("document.all.heading.style.color=\"#f53030\"", 150);
	setTimeout("document.all.heading.style.color=\"#f54040\"", 200);
	setTimeout("document.all.heading.style.color=\"#f55050\"", 250);
	setTimeout("document.all.heading.style.color=\"#f56060\"", 300);
	setTimeout("document.all.heading.style.color=\"#f57070\"", 350);
	setTimeout("document.all.heading.style.color=\"#f57070\"", 350);
	setTimeout("document.all.heading.style.color=\"#f58080\"", 400);
	setTimeout("document.all.heading.style.color=\"#f59090\"", 450);
	setTimeout("document.all.heading.style.color=\"#f5a0a0\"", 500);
	setTimeout("document.all.heading.style.color=\"#f5b0b0\"", 550);
	setTimeout("document.all.heading.style.color=\"#f5c0b3\"", 600);
	setTimeout("document.all.heading.style.color=\"#f5d0b3\"", 650);
	setTimeout("document.all.heading.style.color=\"#f5d0b3\"", 700);
	setTimeout("document.all.heading.style.color=\"#F5DEB3\"", 750);
}
'! !

!PresentationPageDecoration methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 16:32'!
subtitle: aString

	subtitle := aString! !

!PresentationPageDecoration methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 16:33'!
hasNextPage

	^[self component next notNil] on: MessageNotUnderstood do: [:ex | false]! !

!PresentationPageDecoration methodsFor: 'rendering' stamp: 'btb 4/26/2004 19:39'!
style

	^'
body {
    margin:5px 5px 5px 5px;
    padding:0px;
    background:#f6f6f6;
    color:#000000;
    font-family:"Trebuchet MS",Trebuchet,Verdana,Sans-Serif;
}
a{
    color:#800000;
    text-decoration:none;
}
a:hover{
    color:#E0AD12;
}
.title {
    padding:0px 5px 5px 10px;
    border-top:1px solid #800000;
    border-bottom:dotted 1px #800000;
    background:#800000;
    font-weight:bold;
    color:#F5DEB3;
}

.title .heading {
	margin: 0px 0px 0px 0px;
	border-bottom:solid 1px #FFDE80;
	font-weight:bold;
	font-size:350%;
	letter-spacing:-1px;
}

.title .description{
    margin: 0px 0px 0px 0px;
    font-size: 200%;
}
.title .utility {
	position: fixed;
	right: 10px;
	top: 75px;
}
.title .utility a {
	color:#F5DEB3;
}

.subtitle {
    margin:15px 0px 0px 10px;
    color:#9E2505;
    font-weight:bold;
    font-size: 250%;
}
.content {
    margin: 0px 0px 0px 10px;
    color:#800000;
    font-size: 250%;
    letter-spacing:-1px;
}

.subtext {
	font-size:70%;
}

ol {
	margin: 5px 0px 0px 40px;
}
ul  {
	margin: 5px 0px 0px 45px;
}
'! !

!PresentationPageDecoration methodsFor: 'as yet unclassified' stamp: 'btb 4/25/2004 16:28'!
subtitle

	^subtitle ifNil: [subtitle := self obtainSubtitle]! !
PresentationTitlePage initialize!
